unit frmAbout;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, VA508AccessibilityManager, jpeg;

type
  TfrmAbout1 = class(TForm)
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    lblHelpDeskNumber: TVA508StaticText;
    lblService: TVA508StaticText;
    lblFileVersion: TVA508StaticText;
    Image1: TImage;
    VA508StaticText1: TVA508StaticText;
    lblAppWebSite: TStaticText;
    lblVDLWebSite: TStaticText;
    procedure FormCreate(Sender: TObject);
    procedure lblAppWebSiteMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmAbout1: TfrmAbout1;

implementation

{$R *.DFM}

uses VAUtils, ShellApi;

procedure TfrmAbout1.FormCreate(Sender: TObject);
begin
 lblFileVersion.Caption  := 'Version: ' + FileVersionValue(Application.ExeName, FILE_VER_FILEVERSION);;
 lblService.Caption  := 'Developed by the ' + FileVersionValue(Application.ExeName, FILE_VER_COMPANYNAME);
 lblHelpDeskNumber.Caption  := FileVersionValue(Application.ExeName, FILE_VER_COMMENTS);
end;

procedure TfrmAbout1.lblAppWebSiteMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  AFile: String;
begin
  if Not (Sender is TStaticText) then Exit;
  AFile := TStaticText(Sender).Caption;
  ShellExecute(Handle, 'open', PChar(AFile), '', '', SW_NORMAL);
end;

end.
