Unit frmPrintData;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, Menus, ImgList, ToolWin,
  Buttons, OleServer, ComObj, Printers, ActiveX, ORCtrls, Inifiles, Shellapi,
  RpDefine, VA508AccessibilityManager;

type
  TfrmPrintData = class(TForm)
    pnl_Main: TPanel;
    pnl_Patients: TPanel;
    Timer1: TTimer;
    lbxPatients: TORListBox;
    pnl_Top: TPanel;
    pnl_demo: TPanel;
    pnl_Bottom: TPanel;
    PopupMenu1: TPopupMenu;
    DeletePatientfromList: TMenuItem;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Print1: TMenuItem;
    Preview1: TMenuItem;
    Exit1: TMenuItem;
    HOTeam1: TMenuItem;
    SelectProvider1: TMenuItem;
    Save1: TMenuItem;
    Help1: TMenuItem;
    TeamInfo1: TMenuItem;
    CheckforData1: TMenuItem;
    pnl_left: TPanel;
    pnl_middle: TPanel;
    pnl_right: TPanel;
    pnl_lbl_temp1: TPanel;
    lblField1: TLabel;
    pnl_mm_temp1: TPanel;
    Field1: TRichEdit;
    pnl_lbl_temp2: TPanel;
    lblField2: TLabel;
    pnl_mm_temp2: TPanel;
    Field2: TRichEdit;
    pnl_lbl_temp3: TPanel;
    pnl_mm_temp3: TPanel;
    lblField3: TLabel;
    Field3: TRichEdit;
    pnl_lbl_Meds: TPanel;
    lblMeds: TLabel;
    pnl_lbx_meds: TPanel;
    pnl_lbl_temp4: TPanel;
    pnl_mm_temp4: TPanel;
    Field4: TRichEdit;
    Medications: TORListBox;
    pnl_lbx_Consults: TPanel;
    Consult: TORListBox;
    pnl_lbl_Consults: TPanel;
    lblConsults: TLabel;
    pnl_lbx_LabRad: TPanel;
    LabRad: TORListBox;
    pnl_lbl_LabRad: TPanel;
    lblLabsRad: TLabel;
    pnl_lbx_Allergies: TPanel;
    Allergies: TListBox;
    pnl_lbl_Allergies: TPanel;
    lblAllergies: TLabel;
    pnl_cvr_phy: TPanel;
    lblField4: TLabel;
    pnl_demo_col1: TPanel;
    lblName: TLabel;
    lblLOC: TLabel;
    lblSpecialty: TLabel;
    pnl_admdx: TPanel;
    pnl_admdx_col1: TPanel;
    lblADMDX: TLabel;
    pnl_demo_col2: TPanel;
    pnl_demo_col3: TPanel;
    lblSSN: TLabel;
    lblRoom: TLabel;
    lblATTN: TLabel;
    pnl_demo_col4: TPanel;
    pnl_demo_col5: TPanel;
    lblAGE: TLabel;
    lblDOB: TLabel;
    lblPCP: TLabel;
    pnl_demo_col6: TPanel;
    pnl_demo_col8: TPanel;
    edtLoc: TORAlignEdit;
    edtName: TORAlignEdit;
    edtSpec: TORAlignEdit;
    edtSSN: TORAlignEdit;
    edtRoom: TORAlignEdit;
    edtAttn: TORAlignEdit;
    edtAge: TORAlignEdit;
    edtDOB: TORAlignEdit;
    edtPCP: TORAlignEdit;
    edtSex: TORAlignEdit;
    edtAdmDate: TORAlignEdit;
    edtAdmDay: TORAlignEdit;
    pnl_demo_col7: TPanel;
    lblSEX: TLabel;
    lblADMDT: TLabel;
    lblDAYADM: TLabel;
    pnl_admdx_col2: TPanel;
    edtAdmDx: TORAlignEdit;
    pnl_cvr_phy_col2: TPanel;
    pnl_cvr_phy_col1: TPanel;
    lblCoverPhy: TLabel;
    Covering_Physician: TORAlignEdit;
    RichEdit1: TRichEdit;
    PageControl1: TPageControl;
    TabCodeStatus: TTabSheet;
    pnl_CodeSt: TPanel;
    pnl_mm_codest: TPanel;
    Code_Status: TMemo;
    TabContactInfo: TTabSheet;
    pnl_Contact: TPanel;
    pnl_Contact_col4: TPanel;
    mm_Student: TMemo;
    pnl_contact_col3: TPanel;
    lblStudent: TLabel;
    lblNurse: TLabel;
    lblOther: TLabel;
    pnl_contact_col1: TPanel;
    lblResident: TLabel;
    lblRes: TLabel;
    lblIntern: TLabel;
    lblFellow: TLabel;
    pnl_contact_col2: TPanel;
    mm_Resident: TMemo;
    Splitter2: TSplitter;
    Splitter3: TSplitter;
    Splitter4: TSplitter;
    Splitter5: TSplitter;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    Splitter1: TSplitter;
    HelpContent: TMenuItem;
    procedure pnl_middleExit(Sender: TObject);
    procedure pnl_leftExit(Sender: TObject);
    procedure pnl_BottomResize(Sender: TObject);
    procedure pnl_demoResize(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure lbxPatientsClick(Sender: TObject);
    procedure lbxPatientsChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure DeletePatientfromListClick(Sender: TObject);
    procedure lbxPatientsMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Save1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure SelectProvider1Click(Sender: TObject);
    procedure Covering_PhysicianExit(Sender: TObject);
    procedure Covering_PhysicianKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CheckforData1Click(Sender: TObject);
    procedure Field1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Field1Exit(Sender: TObject);
    procedure Field1Enter(Sender: TObject);
    procedure Field2Enter(Sender: TObject);
    procedure Field2Exit(Sender: TObject);
    procedure Field2KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Field3Enter(Sender: TObject);
    procedure Field3Exit(Sender: TObject);
    procedure Field3KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Field4Enter(Sender: TObject);
    procedure Field4Exit(Sender: TObject);
    procedure Field4KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure HelpContentClick(Sender: TObject);
  private
    { Private declarations }
     OK : Boolean;
     RecLocked : Boolean;
     ResidentLstChg: Boolean;
     StudentLstChg : Boolean;
     Temp1changed : Boolean;
     Temp2changed : Boolean;
     Temp3changed : Boolean;
     Temp4changed : Boolean;
     CoveringPhyChanged : Boolean;
     TempFlds : Integer;
     vColorBx : TColor;
     vColorF  : TColor;
    procedure SaveCommentToVista(FLDNAME, DUZ, DFN : String; re : TStrings);
    procedure ClearOutObjs;
    procedure DataHasChanged;
    procedure PrintPortait(SortList: TStrings; Sdr: TObject);
    procedure ChangeFontResize(FontS : TFont);
    procedure Resizeflds(FontS : integer);
   public
    { Public declarations }
    PatientList : TStrings;
    PrefS : String;
    ListName2   : String;
    TotalPages : integer;
    procedure GetTopData(Str : String);
    procedure GetBottomData(Lst : TStrings; RPC, value : String);
    procedure GetContactInfo(LN : String);
  end;


var
  fPrintData: TfrmPrintData;

procedure PrintDataList(FList: TStrings; ListName, PrefL: String; iindex: integer);
function IsRecordLocked(DFN, FLDNAME : String): Boolean;
function FilteredString(const X: string; ATabWidth: Integer = 8): string;
procedure FilteredStrings(var aStrings: TStringList; ATabWidth: Integer = 8);
procedure FilteredCTRLStrings(aCtrl: tWincontrol; ATabWidth: Integer = 8);

implementation

{$R *.DFM}
uses  ORfn,  frmMain,  rOptions, orNet,  WinSpool,
 Util, frmProviderTreeV, frmTeamI,
 frmPrintReport;

const
  xlWBATWorksheet = -4167;
//PrintData----------------------------------------------
// =============================================================================
// Modified By:   ZZZZZZBELLC
// DateTime:      2017.8.14
// Description:
// (1) Clean up variables
// =============================================================================
procedure PrintDataList(FList : TStrings; ListName, PrefL : String ; iindex: integer);
// create the form and make it modal, return an action
var
  frmPrintData: TfrmPrintData;
  i: integer;
  aStrList : TStringList;
  Mi : TMenuItem;
begin
  aStrList := TStringList.Create;
  aStrList.Clear;
  frmPrintData := TfrmPrintData.Create(Application);
  try
  with frmPrintData do
    begin
      ChangeFontResize(frmListSelect.Font);
      ListName2 := ListName;
      PrefS := PrefL;
      GetContactInfo(ListName);

      i := pos('^HOTEAM',ListName2);

      if i> 0 then aStrList.AddStrings(SubSetHOTeamMembers(ListName2, '', 1, 1));

      if (i=0) or ((i>0) and (aStrList.Count=0))  then
        begin
          Mi := MainMenu1.Items.Find('H.O.T. List');
          if Mi <> nil then Mi.Enabled := False;
        end;
       aStrList.Clear;

      lbxPatients.Items :=  FList;

      if lbxPatients.Items.count > 0 then
        begin
          OK := True;

          lbxPatients.ItemIndex := iindex;
          lbxPatientsClick(frmPrintData.lbxPatients);
        end;

      ShowModal;
    end;
  finally
      frmPrintData.Free;
  end;
end;

procedure TfrmPrintData.FormDestroy(Sender: TObject);
begin
SCREEN.OnActiveFormChange := nil;
end;

procedure TfrmPrintData.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Save1Click(Sender);
  Close;
end;

// =============================================================================
// Modified By:   ZZZZZZBELLC
// DateTime:      2017.8.14
// Description:
// (1) Clean up variables
// (2) Filter Strings
// =============================================================================
procedure TfrmPrintData.DataHasChanged;
var
aStrList : TStringList;
begin
if Temp1changed then
   begin
   RecLocked := IsRecordLocked(piece(lbxPatients.Items[lbxPatients.itemindex],'^',1),lblField1.Caption );
   if not RecLocked then
    begin
     FilteredCTRLStrings(Field1);
     SaveCommentToVista(frmListSelect.UserPar.TEMP_FLD_1_TITLE, frmListSelect.DUZ ,piece(lbxPatients.Items[lbxPatients.itemindex],'^',1),  Field1.Lines);
     Temp1changed := False;
    end
    else showMessage(lblField1.Caption + ' - Locked by another user');
   end;

if Temp2changed then
   begin
      RecLocked := IsRecordLocked(piece(lbxPatients.Items[lbxPatients.itemindex],'^',1),lblField2.Caption );
      if not RecLocked then
      begin
        FilteredCTRLStrings(Field2);
        SaveCommentToVista(frmListSelect.UserPar.TEMP_FLD_2_TITLE, frmListSelect.DUZ , piece(lbxPatients.Items[lbxPatients.itemindex],'^',1),  Field2.Lines);
        Temp2changed := False;
      end
       else showMessage(lblField2.Caption + ' - Locked by another user');
   end;

if Temp3changed then
   begin
      RecLocked := IsRecordLocked(piece(lbxPatients.Items[lbxPatients.itemindex],'^',1),lblField3.Caption );
      if not RecLocked then
      begin
       FilteredCTRLStrings(Field3);
       SaveCommentToVista(frmListSelect.UserPar.TEMP_FLD_3_TITLE, frmListSelect.DUZ ,piece(lbxPatients.Items[lbxPatients.itemindex],'^',1),  Field3.Lines);
       Temp3changed := False;
   end
    else showMessage(lblField3.Caption + ' - Locked by another user');
   end;

if Temp4changed then
   begin
      RecLocked := IsRecordLocked(piece(lbxPatients.Items[lbxPatients.itemindex],'^',1),lblField4.Caption );
      if not RecLocked then
      begin
       FilteredCTRLStrings(Field4);
       SaveCommentToVista(frmListSelect.UserPar.TEMP_FLD_4_TITLE, frmListSelect.DUZ ,piece(lbxPatients.Items[lbxPatients.itemindex],'^',1),  Field4.Lines);
       Temp4changed := False;
   end
    else showMessage(lblField4.Caption + ' - Locked by another user');
   end;


   if CoveringPhyChanged then
   begin
   RecLocked := IsRecordLocked(piece(lbxPatients.Items[lbxPatients.itemindex],'^',1),'Covering Physician' );
   if not RecLocked then
    begin
     aStrList := TStringList.Create;
     try
       aStrList.Clear;

       if (Covering_Physician.Text <> '') or (Covering_Physician.Text = '') then
         begin
          aStrList.Add(Covering_Physician.Text);
          FilteredStrings(aStrList);
          SaveCommentToVista('Covering Physician', frmListSelect.DUZ ,piece(lbxPatients.Items[lbxPatients.itemindex],'^',1),  aStrList);
        end;

       CoveringPhyChanged := False;
     finally
      aStrList.Free;
     end;
    end
    else showMessage('Covering Physician' + ' - Locked by another user');
   end;

end;

procedure TfrmPrintData.SaveCommentToVista(FLDNAME, DUZ, DFN : String; re: TStrings);
begin
 CallV('CRHD SAVE TEMP FLD', [FLDNAME, DUZ, DFN, re]);
end;

// =============================================================================
// Modified By:   ZZZZZZBELLC
// DateTime:      2017.8.14
// Description:
// (1) Clean up variables
// (2) Filter Strings
// =============================================================================
procedure TfrmPrintData.lbxPatientsClick(Sender: TObject);
var
aStrList :  TStringList;
uDiv : String;
begin
//is someone editing this record?
//if so record locked.
if OK then
begin
aStrList  := TStringList.Create;
aStrList.clear;
Field1.Hint := '';
Field2.Hint := '';
Field3.Hint := '';
Field4.Hint := '';
Allergies.Items.BeginUpdate;
Code_Status.Lines.BeginUpdate;
Medications.Items.BeginUpdate;
Consult.Items.BeginUpdate;
LabRad.Items.BeginUpdate;
Field1.Lines.BeginUpdate;
Field2.Lines.BeginUpdate;
Field3.Lines.BeginUpdate;
Field4.Lines.BeginUpdate;

tCallV(aStrList,'CRHD PAT DEMO',[piece(lbxPatients.Items[lbxPatients.itemindex],'^',1) + '^'+ 'ALL^132^0']);
if aStrList.Count > 0 then
begin
FilteredStrings(aStrList);
GetTopData(aStrList[0]);
end;

ClearOutObjs;

aStrList.Clear;
GetBottomData(aStrList,'CRHD PAT ALLERGIES', piece(lbxPatients.Items[lbxPatients.itemindex],'^',1)+ '^' + '0^0');
if aStrList.count > 0 then
begin
aStrList.Delete(0);
FilteredStrings(aStrList);
Allergies.Items.AddStrings(aStrList);
end;

if (pos('^DIV', PrefS)>0 )or (pos(';DIC(4,', PrefS)>0 ) then uDiv := piece(piece(frmListSelect.Pref,'^',2),';',1)
else uDiv := piece(frmListSelect.vDiv,'^',1);

aStrList.Clear;
GetBottomData(aStrList,'CRHD PAT CODESTS', piece(lbxPatients.Items[lbxPatients.itemindex],'^',1) + '^' + '^'+ uDiv + '^254^1^' + IntToStr(frmListSelect.UserPar.MULTI_DNR));
if aStrList.count > 0 then
begin
aStrList.Delete(0);
FilteredStrings(aStrList);
Code_Status.Lines.AddStrings(aStrList);
end;

aStrList.Clear;
GetBottomData(aStrList,'CRHD PAT ACTMEDS', piece(lbxPatients.Items[lbxPatients.itemindex],'^',1) + '^' + 'I^'+ IntToStr(frmListSelect.UserPar.MED_EXCLUDE_IV) + '^0^0^' + IntToStr(frmListSelect.UserPar.MED_DETAIL_FLG) +'^50' );
if aStrList.count > 0 then
begin
aStrList.Delete(0);
FilteredStrings(aStrList);
Medications.Items.AddStrings(aStrList);
end;

If frmListSelect.UserPar.CONSULTS = 1 then
  GetBottomData(Consult.Items,'CRHD GET CONSULT', piece(lbxPatients.Items[lbxPatients.itemindex],'^',1) + '^' + '0^0^0^40' );
  FilteredCTRLStrings(Consult);

  aStrList.Clear;
If frmListSelect.UserPar.LABS_IMAGING = 1 then
  begin
    GetBottomData(LabRad.Items,'CRHD GET LABS', piece(lbxPatients.Items[lbxPatients.itemindex],'^',1) + '^' + '0^0^0^40' );
    FilteredCTRLStrings(LabRad);
    GetBottomData(aStrList,'CRHD GET IMAGING', piece(lbxPatients.Items[lbxPatients.itemindex],'^',1) + '^' + '0^0^0^40' );
    if aStrList.count > 0 then
      begin
       FilteredStrings(aStrList);
       LabRad.Items.Add('<<Imaging >>');
        LabRad.Items.AddStrings(aStrList);
      end;
  end;


aStrList.Clear;
GetBottomData(aStrList, 'CRHD GET TEMP FLD', 'Covering Physician' + '^' + frmListSelect.DUZ + '^' + piece(lbxPatients.Items[lbxPatients.itemindex],'^',1) + '^^'+ frmListSelect.vDiv + '^'+ PrefS);
Covering_Physician.Font.Size := frmListSelect.Font.Size;
if aStrList.count >0 then
  begin
   aStrList.Delete(0);
   if aStrList.count > 0 then begin
   FilteredStrings(aStrList);
   Covering_Physician.Text := aStrList[0];
   end;
   end;


aStrList.Clear;
if frmListSelect.UserPar.TEMP_FLD_1_TITLE <> '' then GetBottomData(aStrList, 'CRHD GET TEMP FLD', frmListSelect.UserPar.TEMP_FLD_1_TITLE + '^' + frmListSelect.DUZ + '^' + piece(lbxPatients.Items[lbxPatients.itemindex],'^',1) + '^^'+ frmListSelect.vDiv + '^'+ PrefS);
Field1.Font.Size := frmListSelect.Font.Size;
if aStrList.count > 0 then
   begin
   FilteredStrings(aStrList);
     if frmListSelect.UserPar.TEMP_FLD_1_TITLE = '~NOTE DATA~' then
       begin
         if piece(frmListSelect.UserPar.TEMP_FLD_1_TITLE,'~',3) <> '' then lblField1.Caption := piece(frmListSelect.UserPar.TEMP_FLD_1_TITLE,'~',3);
         Field1.Lines.AddStrings(aStrList);
         Field1.ReadOnly := True;
       end
       else
       begin
         Field1.Hint := 'Last Edit by: ' + piece(aStrList[0],'^',3) + ' - ' + piece(aStrList[0],'^',2);
         aStrList.Delete(0);
         Field1.Lines.AddStrings(aStrList);
         Field1.ReadOnly := False;
        end;
   end;
aStrList.Clear;
if frmListSelect.UserPar.TEMP_FLD_2_TITLE <> '' then GetBottomData(aStrList,'CRHD GET TEMP FLD',  frmListSelect.UserPar.TEMP_FLD_2_TITLE + '^' + frmListSelect.DUZ + '^' + piece(lbxPatients.Items[lbxPatients.itemindex],'^',1) + '^^' + frmListSelect.vDiv+ '^'+ PrefS);
Field2.Font.Size := frmListSelect.Font.Size;
if aStrList.count > 0 then
   begin
   FilteredStrings(aStrList);
     if frmListSelect.UserPar.TEMP_FLD_2_TITLE = '~NOTE DATA~' then
     begin
       if piece(frmListSelect.UserPar.TEMP_FLD_2_TITLE,'~',3) <> '' then lblField2.Caption := piece(frmListSelect.UserPar.TEMP_FLD_2_TITLE,'~',3);
       Field2.Lines.AddStrings(aStrList);
       Field2.ReadOnly := True;
     end
     else
     begin
       Field2.Hint := 'Last Edit by: ' + piece(aStrList[0],'^',3) + ' - ' + piece(aStrList[0],'^',2);
       aStrList.Delete(0);
       Field2.Lines.AddStrings(aStrList);
       Field2.ReadOnly := False;
     end;
   end;

aStrList.Clear;
if frmListSelect.UserPar.TEMP_FLD_3_TITLE <> '' then GetBottomData(aStrList, 'CRHD GET TEMP FLD', frmListSelect.UserPar.TEMP_FLD_3_TITLE + '^' + frmListSelect.DUZ + '^' + piece(lbxPatients.Items[lbxPatients.itemindex],'^',1) + '^^' + frmListSelect.vDiv + '^'+ PrefS);
Field3.Font.Size := frmListSelect.Font.Size;
if aStrList.count > 0 then
  begin
  FilteredStrings(aStrList);
     if frmListSelect.UserPar.TEMP_FLD_3_TITLE = '~NOTE DATA~' then
     begin
       if piece(frmListSelect.UserPar.TEMP_FLD_3_TITLE,'~',3) <> '' then lblField3.Caption := piece(frmListSelect.UserPar.TEMP_FLD_3_TITLE,'~',3);
       Field3.Lines.AddStrings(aStrList);
       Field3.ReadOnly := True;
     end
     else
  begin
    Field3.Hint := 'Last Edit by: ' + piece(aStrList[0],'^',3) + ' - ' + piece(aStrList[0],'^',2);
    aStrList.Delete(0);
    Field3.Lines.AddStrings(aStrList);
    Field3.ReadOnly := False;
  end;
  end;
  aStrList.Clear;
  if frmListSelect.UserPar.TEMP_FLD_4_TITLE <> '' then GetBottomData(aStrList, 'CRHD GET TEMP FLD', frmListSelect.UserPar.TEMP_FLD_4_TITLE + '^' + frmListSelect.DUZ + '^' + piece(lbxPatients.Items[lbxPatients.itemindex],'^',1) + '^^' + frmListSelect.vDiv + '^'+ PrefS);
  Field4.Font.Size := frmListSelect.Font.Size;
  if aStrList.count > 0 then
    begin
    FilteredStrings(aStrList);
      if frmListSelect.UserPar.TEMP_FLD_4_TITLE = '~NOTE DATA~' then
        begin
          if piece(frmListSelect.UserPar.TEMP_FLD_4_TITLE,'~',3) <> '' then lblField4.Caption := piece(frmListSelect.UserPar.TEMP_FLD_4_TITLE,'~',3);
          Field4.Lines.AddStrings(aStrList);
          Field4.ReadOnly := True;
        end
        else
        begin
          Field4.Hint := 'Last Edit by: ' + piece(aStrList[0],'^',3) + ' - ' + piece(aStrList[0],'^',2);
          aStrList.Delete(0);
          Field4.Lines.AddStrings(aStrList);
          Field4.ReadOnly := False;
        end;
     end;
    end;

Allergies.Items.EndUpdate;
Code_Status.Lines.EndUpdate;
Medications.Items.EndUpdate;
Consult.Items.EndUpdate;
LabRad.Items.EndUpdate;
Field1.Lines.EndUpdate;
Field2.Lines.EndUpdate;
Field3.Lines.EndUpdate;
Field4.Lines.EndUpdate;
end;

procedure TfrmPrintData.GetBottomData(Lst: TStrings; RPC, value: String);
begin

if pos('~NOTE DATA~',value)>0 then tCallV(Lst,'CRHD GET TIU TEXT', [piece(value,'^',3), ''])
else tCallV(Lst,RPC ,[value]);
end;

procedure TfrmPrintData.ClearOutObjs;
begin
Allergies.Items.Clear;
Code_Status.Lines.Clear;
Medications.Items.Clear;
Consult.Clear;
LabRad.Items.Clear;
Field1.Lines.Clear;
Field2.Lines.Clear;
Field3.Lines.Clear;
Field4.Lines.Clear;
Covering_Physician.Text := '';
end;


procedure TfrmPrintData.GetTopData(Str: String);
begin
edtName.Text := piece(Str,'^',edtName.Tag);
edtSSN.Text := piece(Str,'^',edtSSN.Tag);
edtRoom.Text := piece(Str,'^',edtRoom.Tag);
edtSpec.Text := piece(Str,'^',edtSpec.Tag);
edtAge.Text := piece(Str,'^',edtAge.Tag);
edtSex.Text := piece(Str,'^',edtSex.Tag);
edtDOB.Text := piece(Str,'^',edtDOB.Tag);
edtLoc.Text := piece(Str,'^',edtLoc.Tag);
edtAdmDx.Text := piece(Str,'^',edtAdmDx.Tag);
edtAdmDate.Text := piece(Str,'^',edtAdmDate.Tag);
edtAdmDay.Text := piece(Str,'^',edtAdmDay.Tag);
edtAttn.Text := piece(Str,'^',edtAttn.Tag);
edtPCP.Text := piece(Str,'^',edtPCP.Tag);
end;

procedure TfrmPrintData.HelpContentClick(Sender: TObject);
begin
  Application.HelpContext(Self.HelpContext);
end;

procedure TfrmPrintData.lbxPatientsChange(Sender: TObject);
begin
DataHasChanged;
end;

procedure TfrmPrintData.FormCreate(Sender: TObject);
var
  h,h2  : integer;
  Mi : TMenuItem;
begin
Tempflds := 0;
 if GetDefaultPrinterName = '' then
 begin
  Mi := MainMenu1.Items[0].Find('&Print Report');
  if Mi <> nil then Mi.Enabled := False;
  Mi := MainMenu1.Items[0].Find('Pre&View Report');
  if Mi <> nil then Mi.Enabled := False;
 end;

with frmListSelect.UserPar do
  begin
      mm_Resident.Color := edtAttn.Color;
      mm_Resident.ReadOnly := True;
      mm_Student.Color := edtAttn.Color;
      mm_Student.ReadOnly := True;

   if TEMP_FLD_COLOR <> '' then vColorBx := StrToInt(TEMP_FLD_COLOR)
   else vColorBx := clYellow;

   if TEMP_FLD_FONTCOLOR <> '' then vColorF := StrToInt(TEMP_FLD_FONTCOLOR)
   else vColorF := clBlack;

   Field1.Color := vColorBx;
   Field2.Color := vColorBx;
   Field3.Color := vColorBx;
   Field4.Color := vColorBx;
   Covering_Physician.Color := vColorBx;

   Field1.Font.Color := vColorF;
   Field2.Font.Color := vColorF;
   Field3.Font.Color := vColorF;
   Field4.Font.Color := vColorF;
   Covering_Physician.Font.Color := vColorF;



    if TEMP_FLD_1_TITLE <> '' then
    begin
     lblField1.Caption := TEMP_FLD_1_TITLE;
     inc(Tempflds);
    end
    else
      begin
         TempFlds := 0;
         Field1.Visible := False;
         lblField1.Visible := False;
         pnl_lbl_temp1.Visible := False;
         pnl_mm_temp1.Visible := False;
      end;

    if TEMP_FLD_2_TITLE <> '' then
      begin
       inc(Tempflds);
       pnl_lbl_temp2.Visible := True;
       pnl_mm_temp2.Visible := True;
       lblField2.Caption := TEMP_FLD_2_TITLE;
       if (TEMP_FLD_3_TITLE = '') then
         begin
           pnl_lbl_temp3.Visible := False;
           pnl_mm_temp3.Visible := False;
           h := pnl_Left.Height - pnl_lbl_temp1.Height - pnl_lbl_temp2.Height;
           h := Trunc(h/2);
           pnl_mm_temp1.Height := h;
           pnl_lbl_temp2.Top := pnl_lbl_temp1.Height + pnl_mm_temp1.Height;
           pnl_mm_temp2.Align := alClient;
         end;
      end
    else
       begin
         pnl_lbl_temp2.Visible := False;
         pnl_mm_temp2.Visible := False;
         if Field1.Visible then
            begin
            pnl_mm_temp1.Align := alClient;
            end;
         end;


    if TEMP_FLD_3_TITLE <> '' then
    begin
     lblField3.Caption := TEMP_FLD_3_TITLE;
     inc(Tempflds);
    end
    else
      begin
         pnl_lbl_temp3.Visible := False;
         pnl_mm_temp3.Visible := False;
      end;

    if TEMP_FLD_4_TITLE <> '' then
    begin
     lblField4.Caption := TEMP_FLD_4_TITLE;
     inc(Tempflds);
    end
    else
      begin
        pnl_lbl_temp4.Visible := False;
        pnl_mm_temp4.Visible := False;
        pnl_lbx_Meds.Align := alClient;
      end;

      if ((not pnl_mm_temp1.Visible) and (not pnl_mm_temp2.Visible) and (not pnl_mm_temp3.Visible)) then pnl_Left.Visible := False
      else pnl_Left.Visible := True;


          h := pnl_Right.Height - pnl_cvr_phy.Height - pnl_lbl_Allergies.Height- pnl_lbl_LabRad.Height;
          h2 :=pnl_Right.Height - pnl_cvr_phy.Height - pnl_lbl_Allergies.Height- pnl_lbl_LabRad.Height-pnl_lbl_Consults.Height;
          h := Trunc(h/2);
          h2 := Trunc(h2/3);

          pnl_lbx_Allergies.Align := alTop;

          if frmListSelect.UserPar.LABS_IMAGING = 0 then
          begin
           pnl_lbl_LabRad.Visible := False;
           pnl_lbx_LabRad.Visible := False;
           if frmListSelect.UserPar.CONSULTS = 0 then
           begin
            pnl_lbl_Consults.Visible := False;
            pnl_lbx_Consults.Visible := False;
            pnl_lbx_Allergies.Align := alClient;
           end
           else
             begin
              pnl_lbx_Allergies.Height := h;
              pnl_lbx_Consults.Align := alClient;
             end;
          end
          else
          begin
              pnl_lbx_LabRad.Visible := True;
              pnl_lbl_LabRad.Visible := True;
              if frmListSelect.UserPar.CONSULTS = 0 then
                begin
                 pnl_lbx_Allergies.Height := h;
                 pnl_lbl_LabRad.Align := alTop;
                 pnl_lbx_LabRad.Align := alClient;
                end;
         end;

         if frmListSelect.UserPar.CONSULTS = 0 then
          begin
           pnl_lbl_Consults.Visible := False;
           pnl_lbx_Consults.Visible := False;
          end
          else
            begin
              pnl_lbx_Consults.Visible := True;
              pnl_lbl_Consults.Visible := True;
              if frmListSelect.UserPar.LABS_IMAGING = 0 then
                begin
                  pnl_lbx_Allergies.Height := h;
                  pnl_lbl_Consults.Align := alTop;
                  pnl_lbx_Consults.Align := alTop;
                  Consult.Height := h2;
                end;
              end;
            end;



PatientList := TStringList.Create;
PatientList.Clear;
end;

procedure TfrmPrintData.FormShow(Sender: TObject);
begin
ResidentLstChg := False;
StudentLstChg := False;
Temp1changed := False;
Temp2changed := False;
Temp3changed := False;
Temp4changed := False;
CoveringPhyChanged := False;
end;

procedure TfrmPrintData.Exit1Click(Sender: TObject);
begin
DataHasChanged;
PatientList.Clear;
PatientList.AddStrings(lbxPatients.Items);
Close;
end;

procedure TfrmPrintData.DeletePatientfromListClick(Sender: TObject);
var
idx : integer;
begin
    idx := CurrentIndex(lbxPatients.ItemIndex, lbxPatients.Items.Count);

    ClearOutObjs;
    GetTopData('');

  lbxPatients.Items.BeginUpdate;
  lbxPatients.Items.Delete(lbxPatients.ItemIndex) ;
  lbxPatients.ItemIndex := idx ;
  if lbxPatients.Items.Count > 0 then
  begin

    OK := True;
    lbxPatientsClick(lbxPatients);
    lbxPatients.Items.EndUpdate;
  end
  else
   Exit1Click(MainMenu1);
end;

procedure TfrmPrintData.lbxPatientsMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
if Button = mbLeft then OK := True
else OK := False;
end;

procedure TfrmPrintData.pnl_BottomResize(Sender: TObject);
var
w, h : integer;
begin
  w := Trunc(pnl_Main.Width/3);
  pnl_Left.Width := w;
  pnl_Right.Width := w;


  case Tempflds of
          1 : pnl_mm_Temp1.Height := pnl_left.Height-pnl_lbl_temp1.Height;
       2..3 : begin
            h := pnl_left.Height - pnl_lbl_temp1.Height - pnl_lbl_temp2.Height;
            if Tempflds = 3 then h := h - pnl_lbl_temp3.Height;
            h := Trunc(h/Tempflds);
            pnl_mm_Temp1.Height := h;
            pnl_mm_Temp2.Height := h;
            if Tempflds = 3 then pnl_mm_Temp3.Height := h;
           end;
       4 : begin
            h := pnl_left.Height - pnl_lbl_temp1.Height - pnl_lbl_temp2.Height- pnl_lbl_temp3.Height ;
            h := Trunc(h/3);
            pnl_mm_Temp1.Height := h;
            pnl_mm_Temp2.Height := h;
            pnl_mm_Temp3.Height := h;
            pnl_mm_Temp4.Height := pnl_mm_Temp3.Height;
       end;
  end;

  if ((LabRad.Visible) and (Consult.Visible)) then
  begin
     h := pnl_Right.Height - pnl_cvr_phy.Height - pnl_lbl_Allergies.Height - pnl_lbl_LabRad.Height - pnl_lbl_Consults.Height;
     h := Trunc(h/3);
     pnl_lbx_Consults.Height := h;
     pnl_lbx_LabRad.Height := h;
     pnl_lbx_Allergies.Height := h;
  end
  else
    if LabRad.Visible then
     begin
     h := pnl_Right.Height - pnl_cvr_phy.Height - pnl_lbx_Allergies.Height - pnl_lbl_LabRad.Height;
     h := Trunc(h/2);
     pnl_lbx_LabRad.Height := h;
     pnl_lbx_Allergies.Height := h;
     end
     else
      begin
       h := pnl_Right.Height - pnl_cvr_phy.Height - pnl_lbx_Allergies.Height - pnl_lbl_Consults.Height;
       h := Trunc(h/2);
       pnl_lbx_Consults.Height := h;
       pnl_lbx_Allergies.Height := h;

      end;



  Field1.Repaint;
  Field2.Repaint;
  Field3.Repaint;
  Field4.Repaint;
end;

procedure TfrmPrintData.pnl_demoResize(Sender: TObject);
var
w, h : integer;
begin
    h := Trunc(pnl_demo.Height/4);
    w := pnl_demo.Width - pnl_demo_col1.Width - pnl_demo_col3.Width - pnl_demo_col5.Width - pnl_demo_col7.Width;
    w := Trunc(w/4);
    pnl_demo_col2.Width := w;
    pnl_demo_col4.Width := w;
    pnl_demo_col6.Width := w;
    pnl_demo_col8.Width := w;

   //calculate size of patient demographic edit box sizes
   //col1,col2
    lblName.Height := h;
    lblSpecialty.Height := h;
    lblADMDX.Height := h;
    edtName.Height := h;
    edtSpec.Height :=h;
    edtAdmDx.Height := h;
    //col3,col4
    lblSSN.Height := h;
    lblAttn.Height := h;
    edtSSN.Height := h;
    edtAttn.Height :=h;
    //col5,col6
    lblAge.Height := h;
    lblPCP.Height := h;
    edtAge.Height := h;
    edtPCP.Height :=h;
    //col7,col8
    lblSex.Height := h;
    lblDAYADM.Height := h;
    edtSex.Height := h;
    edtAdmDay.Height :=h;
end;

procedure TfrmPrintData.pnl_leftExit(Sender: TObject);
begin
DataHasChanged;
end;

procedure TfrmPrintData.pnl_middleExit(Sender: TObject);
begin
DataHasChanged;
end;

function IsRecordLocked(DFN, FLDNAME : String): Boolean;
var
rtn : String;
begin
rtn := sCallV('CRHD IS RECORD LOCKED', [DFN, FLDNAME]);
if rtn = '1' then Result := True
else Result := False;
end;

procedure TfrmPrintData.Save1Click(Sender: TObject);
begin
DataHasChanged;
PatientList.Clear;
PatientList.AddStrings(lbxPatients.Items);
end;

// =============================================================================
// Modified By:   ZZZZZZBELLC
// DateTime:      2017.8.14
// Description:
// (1) Clean up variables
// =============================================================================
procedure TfrmPrintData.Print1Click(Sender: TObject);
var
  SortList: TStringList;
begin
  Save1Click(MainMenu1);
  SortList := TStringList.Create;
  try
    if GetDefaultPrinterName = '' then
    begin
      showMessage('You have No Default Printer set up');
      exit;
    end;
    PrintPortait(SortList, Sender);
  finally
    SortList.Free;
  end;
end;

procedure TfrmPrintData.PrintPortait(SortList: TStrings; Sdr: TObject);
var
frmf : TfrmReportM;
begin
  frmf := TfrmReportM.Create(Application);
  try
   frmf.SortList(PatientList, SortList , IntToStr(frmListSelect.UserPar.ORDER_BY));
   if frmf.SomeList = nil then frmf.SomeList := TStringList.Create;
   if SortList.Count > 0 then frmf.SomeList.AddStrings(SortList);
   if sdr = Preview1 then frmf.RvSystem1.DefaultDest := rdPreview
    else frmf.RvSystem1.DefaultDest := rdPrinter;

   frmf.PrintMyReport(ListName2);
  finally
     frmf.Free;
  end;
end;

// =============================================================================
// Modified By:   ZZZZZZBELLC
// DateTime:      2017.8.14
// Description:
// (1) Clean up variables - Extra stringlist
// =============================================================================
procedure TfrmPrintData.SelectProvider1Click(Sender: TObject);
var
tmpS : String;
tmpL : TStrings;
i : integer;
begin
tmpL := TStringList.Create;
try

tmpS := GetHOProviderTreeView(ListName2);

if piece(tmpS,'~',2) = '0' then exit;

tmpL.Clear;

ListofHOPatientsByPrv(tmpL, ListName2, piece(tmpS,'^',1));

if tmpL.Count > 0 then
  begin
    lbxPatients.Clear;
    Field1.Hint := '';
    Field2.Hint := '';
    Field3.Hint := '';
    Field4.Hint := '';
    GetTopData('');
    ClearOutObjs;
    for i:= 0 to tmpL.count -1 do
      begin
        tmpS := pieces(tmpL[i],'^',3,8);
        lbxPatients.items.Add(tmpS);
      end;
      lbxPatients.ItemIndex := 0;
      lbxPatientsClick(lbxPatients);
      end
else
showmessage('No patients found for this Provider');
finally
 tmpL.Free;
end;
end;

procedure TfrmPrintData.Covering_PhysicianExit(Sender: TObject);
begin
if CoveringPhyChanged = True then DataHasChanged;
end;

procedure TfrmPrintData.Covering_PhysicianKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
if not CoveringPhyChanged then CoveringPhyChanged := True;
end;

procedure TfrmPrintData.CheckforData1Click(Sender: TObject);
begin
 DisplayFile(ListName2);
end;

procedure TfrmPrintData.Field1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if not Temp1changed then Temp1changed := True;
end;

procedure TfrmPrintData.Field1Exit(Sender: TObject);
begin
if Temp1Changed = True then DataHasChanged;
end;

procedure TfrmPrintData.Field1Enter(Sender: TObject);
begin
RecLocked := IsRecordLocked(piece(lbxPatients.Items[lbxPatients.itemindex],'^',1), lblField1.Caption);
if RecLocked then showMessage(lblField1.Caption + ' - Locked by another user');
Field1.ReadOnly := RecLocked;
end;

procedure TfrmPrintData.Field2Enter(Sender: TObject);
begin
RecLocked := IsRecordLocked(piece(lbxPatients.Items[lbxPatients.itemindex],'^',1), lblField2.Caption);
if RecLocked then showMessage(lblField2.Caption + ' - Locked by another user');
Field2.ReadOnly := RecLocked;
end;

procedure TfrmPrintData.Field2Exit(Sender: TObject);
begin
if Temp2Changed = True then DataHasChanged;
end;

procedure TfrmPrintData.Field2KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if not Temp2changed then Temp2changed := True;
end;

procedure TfrmPrintData.Field3Enter(Sender: TObject);
begin
RecLocked := IsRecordLocked(piece(lbxPatients.Items[lbxPatients.itemindex],'^',1), lblField3.Caption);
if RecLocked then showMessage(lblField3.Caption + ' - Locked by another user');
Field3.ReadOnly := RecLocked;
end;

procedure TfrmPrintData.Field3Exit(Sender: TObject);
begin
if Temp3Changed = True then DataHasChanged;
end;

procedure TfrmPrintData.Field3KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if not Temp3changed then Temp3changed := True;
end;

procedure TfrmPrintData.Field4Enter(Sender: TObject);
begin
RecLocked := IsRecordLocked(piece(lbxPatients.Items[lbxPatients.itemindex],'^',1), lblField4.Caption);
if RecLocked then showMessage(lblField4.Caption + ' - Locked by another user');
Field4.ReadOnly := RecLocked;
end;

procedure TfrmPrintData.Field4Exit(Sender: TObject);
begin
if Temp4Changed = True then DataHasChanged;
end;

procedure TfrmPrintData.Field4KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if not Temp4changed then Temp4changed := True;
end;

// =============================================================================
// Modified By:   ZZZZZZBELLC
// DateTime:      2017.8.14
// Description:
// (1) Clean up variables - Extra stringlist
// =============================================================================
procedure TfrmPrintData.GetContactInfo(LN : String);
var
 str1, str2, ph : String;
 i, i2 ,n, x, ResidentLineNum, StudentLineNum : integer;
 tmpList, tmpCList,tmpCList2 : TStringList;
begin
  n := 0;
  tmpList := TStringList.Create;
  try
    tmpList.Clear;
    mm_Resident.Lines.Clear;
    mm_Student.Lines.Clear;

    if (pos('^HOTEAM', LN) > 0) then
    begin
      n := 7;
      tCallV(tmpList, 'CRHD HOT PROVIDER LIST', [LN]);
    end
    else
    if (pos('^Combination', LN) > 0) then
    begin
      tmpCList  := TStringList.Create;
      tmpCList2 := TStringList.Create;
      try
        tCallv(tmpCList, 'CRHD COMB TM LIST', []);
        if tmpCList.Count > 0 then
          for i := 0 to tmpCList.Count - 1 do
          begin
            tmpCList2.Clear;
            tCallV(tmpCList2, 'CRHD TM PRV LIST', [tmpCList[i]]);
            n := 5;
            if tmpCList2[0] = 'No list found' then
              tmpCList2.Clear;
            if tmpCList2.Count > 0 then
              for i2 := 0 to tmpCList2.Count - 1 do
                if not findDup(piece(tmpCList2[i2], '^', 2), tmpList) then
                  tmpList.Append(tmpCList2[i2]);
          end;
      finally
        tmpCList2.Free;
        tmpCList.Free;
      end;
    end
    else
    begin
      tCallV(tmpList, 'CRHD TM PRV LIST', [LN]);
      n := 5;
    end;

    if tmpList.Count = 1 then
      if tmpList[0] = 'No list found' then
        tmpList.Clear;

    if tmpList.Count = 0 then
    begin
      mm_Resident.Lines := frmListSelect.UserPar.RESIDENT;
      mm_Student.Lines  := frmListSelect.UserPar.STUDENT;
    end;

    if tmpList.Count > 0 then
    begin
      MixedCaseByPiece(tmpList, '^', 2);
      //Initilize our lines
      for x := 0 to 3 do
        mm_Resident.Lines.Add('');
      for x := 0 to 2 do
        mm_Student.Lines.Add('');

      for i := 0 to tmpList.Count - 1 do
      begin
        str1 := tmpList[i];
        ph := '';
        if (piece(str1, '^', n) <> '') and (piece(str1, '^', n) <> '0') then
          ph := 'Pg: ' + piece(str1, '^', n)
        else
        if (piece(str1, '^', n - 1) <> '') and (piece(str1, '^', n - 1) <> '0') then
          ph := 'Ph: ' + piece(str1, '^', n - 1);

        if (ph = 'Pg: ') or (ph = 'Ph: ') then
          ph := '';
        if piece(str1, '^', 3) <> '' then
          str2 := format('%s (' + copy(piece(str1, '^', 3), 1, 1) + ')  %s', [piece(str1, '^', 2), ph])
        else
          str2 := format('%s %s', [piece(str1, '^', 2), ph]);

        //Clear our line Numbers
        StudentLineNum  := -1;
        ResidentLineNum := -1;

        if piece(str1, '^', 3) = 'ATTN' then
          ResidentLineNum := 0;
        if piece(str1, '^', 3) = 'RES' then
          ResidentLineNum := 1;
        if piece(str1, '^', 3) = 'INTERN' then
          ResidentLineNum := 2;
        if piece(str1, '^', 3) = 'FELLOW' then
          ResidentLineNum := 3;
        if piece(str1, '^', 3) = 'MED STUDENT' then
          StudentLineNum := 0;
        if piece(str1, '^', 3) = 'NURSE' then
          StudentLineNum := 1;
        if piece(str1, '^', 3) = '' then
          StudentLineNum := 2;

        //add our text
        if ResidentLineNum > -1 then
        begin
          if Length(mm_Resident.Lines.Strings[ResidentLineNum]) = 0 then
            mm_Resident.Lines.Strings[ResidentLineNum] := str2
          else
            mm_Resident.Lines.Strings[ResidentLineNum] :=
              mm_Resident.Lines.Strings[ResidentLineNum] + ' ; ' + str2;
        end else if StudentLineNum > -1 then
        begin
          if Length(mm_Student.Lines.Strings[StudentLineNum]) = 0 then
            mm_Student.Lines.Strings[StudentLineNum] := str2
          else
            mm_Student.Lines.Strings[StudentLineNum] :=
              mm_Student.Lines.Strings[StudentLineNum] + ' ; ' + str2;
        end;
      end;
    end;
  finally
    tmpList.Free;
  end;
end;

procedure TfrmPrintData.ChangeFontResize(FontS: TFont);
begin
  Font := FontS;
  Resizeflds(FontS.Size);
end;

procedure TfrmPrintData.Resizeflds(FontS: integer);
begin
case  FontS of
    8 : begin
         pnl_demo_col1.Width := 54;
         pnl_admdx_col1.Width := 54;
         pnl_demo_col3.Width := 49;
         pnl_demo_col5.Width := 38;
         pnl_demo_col7.Width := 63;
         pnl_admdx_col1.Width := 52;
         pnl_lbl_temp1.Height := 30;
         pnl_lbl_temp2.Height := 30;
         pnl_lbl_temp3.Height := 30;
         pnl_lbl_temp4.Height := 30;
         pnl_lbl_Meds.Height := 30;
         pnl_cvr_phy.Height := 30;
         pnl_lbl_Allergies.Height := 30;
         pnl_lbl_LabRad.Height := 30;
         pnl_lbl_Consults.Height := 30;
        end;
    10: begin
         pnl_demo_col1.Width := 54;
         pnl_admdx_col1.Width := 54;
         pnl_demo_col3.Width := 49;
         pnl_demo_col5.Width := 38;
         pnl_demo_col7.Width := 63;
         pnl_admdx_col1.Width := 52;
         pnl_lbl_temp1.Height := 30;
         pnl_lbl_temp2.Height := 30;
         pnl_lbl_temp3.Height := 30;
         pnl_lbl_temp4.Height := 30;
         pnl_lbl_Meds.Height := 30;
         pnl_cvr_phy.Height := 30;
         pnl_lbl_Allergies.Height := 30;
         pnl_lbl_LabRad.Height := 30;
         pnl_lbl_Consults.Height := 30;
        end;
    12: begin
         pnl_demo_col1.Width := 67;
         pnl_admdx_col1.Width := 67;
         pnl_demo_col3.Width := 49;
         pnl_demo_col5.Width := 38;
         pnl_demo_col7.Width := 76;
         pnl_admdx_col1.Width := 67;
         pnl_lbl_temp1.Height := 30;
         pnl_lbl_temp2.Height := 30;
         pnl_lbl_temp3.Height := 30;
         pnl_lbl_temp4.Height := 30;
         pnl_lbl_Meds.Height := 30;
         pnl_cvr_phy.Height := 30;
         pnl_lbl_Allergies.Height := 30;
         pnl_lbl_LabRad.Height := 30;
         pnl_lbl_Consults.Height := 30;
        end;
    18: begin
         pnl_demo_col1.Width := 96;
         pnl_admdx_col1.Width := 96;
         pnl_demo_col3.Width := 69;
         pnl_demo_col5.Width := 55;
         pnl_demo_col7.Width := 110;
         pnl_admdx_col1.Width := 98;
         pnl_lbl_temp1.Height := 36;
         pnl_lbl_temp2.Height := 36;
         pnl_lbl_temp3.Height := 36;
         pnl_lbl_temp4.Height := 36;
         pnl_lbl_Meds.Height := 36;
         pnl_cvr_phy.Height := 36;
         pnl_lbl_Allergies.Height := 36;
         pnl_lbl_LabRad.Height := 36;
         pnl_lbl_Consults.Height := 36;
        end;
    24: begin
         pnl_demo_col1.Width := 134;
         pnl_demo_col3.Width := 90;
         pnl_demo_col5.Width := 72;
         pnl_demo_col7.Width := 152;
         pnl_admdx_col1.Width := 127;
         pnl_lbl_temp1.Height := 38;
         pnl_lbl_temp2.Height := 38;
         pnl_lbl_temp3.Height := 38;
         pnl_lbl_temp4.Height := 38;
         pnl_lbl_Meds.Height := 38;
         pnl_cvr_phy.Height := 38;
         pnl_lbl_Allergies.Height := 38;
         pnl_lbl_LabRad.Height := 38;
         pnl_lbl_Consults.Height := 38;
        end;
    else
end;

end;


procedure TfrmPrintData.FormResize(Sender: TObject);
var
w : integer;
begin
   //calculate size of patient demographic edit box sizes
    w := pnl_demo.Width - pnl_demo_col1.Width - pnl_demo_col3.Width - pnl_demo_col5.Width - pnl_demo_col7.Width;
    w := Trunc(w/4);
    pnl_demo_col2.Width := w;
    pnl_demo_col4.Width := w;
    pnl_demo_col6.Width := w;
    pnl_demo_col8.Width := w;

    //contact section resize
    w := pnl_contact.Width - pnl_contact_col1.Width - pnl_contact_col3.Width;
    w := Trunc(w/2);
    pnl_contact_col2.Width := w;
    pnl_contact_col4.Width := w;

    //resize bottom section with temp, meds, allergy, LabRad, and Consult info.
    w := Trunc(pnl_Main.Width/3);
    pnl_Left.Width := w;
    pnl_Right.Width := w;

    Field1.Repaint;
    Field2.Repaint;
    Field3.Repaint;
    Field4.Repaint;
end;

function FilteredString(const X: string; ATabWidth: Integer = 8): string;
var
  i, j: Integer;
  xc: AnsiChar;
begin
  Result := '';
  for i := 1 to Length(X) do
  begin
    xc := AnsiChar(X[i]);
    case xc of
      #9:
        for j := 1 to (ATabWidth - (Length(Result) mod ATabWidth)) do
          Result := Result + ' ';
      #32 .. #127:
        Result := Result + X[i];
      #128 .. #159:
        Result := Result + '?';
      #10, #13, #160:
        Result := Result + ' ';
      #161 .. #255:
        Result := Result + X[i];
    end;
  end;
  if copy(Result, Length(Result), 1) = ' ' then
    Result := TrimRight(Result) + ' ';
end;

procedure FilteredStrings(var aStrings: TStringList; ATabWidth: Integer = 8);
Var
  i: Integer;
begin
  for i := 0 to aStrings.Count - 1 do
    aStrings.Strings[i] := FilteredString(aStrings.Strings[i], ATabWidth);
end;

procedure FilteredCTRLStrings(aCtrl: tWincontrol; ATabWidth: Integer = 8);
Var
  aTmpLst: TStringList;
begin
  aTmpLst := TStringList.create;
  try
   if aCtrl is TRichEdit then
   begin
    aTmpLst.assign(TRichEdit(aCtrl).lines);
    FilteredStrings(aTmpLst);
    TRichEdit(aCtrl).lines.assign(aTmpLst);
   end else if aCtrl is TOrListBox then
   begin
    aTmpLst.assign(TOrListBox(aCtrl).Items);
    FilteredStrings(aTmpLst);
    TOrListBox(aCtrl).Items.assign(aTmpLst);
   end;
  finally
    aTmpLst.free;
  end;
end;

end.
